unit u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls, Db, DBTables;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    cb1: TComboBox;
    Label2: TLabel;
    cb2: TComboBox;
    Panel2: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    BitBtn1: TBitBtn;
    Button4: TButton;
    SpeedButton1: TSpeedButton;
    db1: TDatabase;
    Table1: TTable;
    Label3: TLabel;
    Edit1: TEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure cb1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    function retrieve_fields:boolean;
    function qname_ok:boolean;
    function return_fldtype(in_ :TFieldType):string;
    function return_astype(in_ :TFieldType):string;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
   a_fldlist :TStringList;
   a_ftlist  :TStringList;
   a_aslist  :TStringList;
   wq_       :string;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     Memo1.SelectAll;
     Memo1.SetFocus;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   s_ :string;
   i_ :integer;
begin
if (retrieve_fields) and (qname_ok) then begin
     memo1.Lines.Clear;
  s_ := 'with ' + wq_ + ' do begin';  memo1.Lines.Add(s_);
  s_ := '  if active then Close; UnPrepare; SQL.Clear;';  memo1.Lines.Add(s_);
  s_ := '  SQL.Add('+''''+'insert into ' + cb2.Text + '(';
for i_ := 0 to a_fldlist.Count - 1 do
begin
  if i_ <> 0 then s_ := s_ + ', ';
  s_ := s_ + a_fldlist.Strings[i_];
end;
  s_ := s_ + ')' + '''' + ');';  memo1.Lines.Add(s_);
  s_ := '  SQL.Add('+''''+'values(';
for i_ := 0 to a_fldlist.Count - 1 do
begin
  if i_ <> 0 then s_ := s_ + ', ';
  s_ := s_ + ':v' + inttostr(i_ + 1);
end;
  s_ := s_ + ')'+ '''' + ');';
  memo1.Lines.Add(s_);
  s_ := '  Params.Clear;';  memo1.Lines.Add(s_);
for i_ := 0 to a_fldlist.Count - 1 do
begin
  s_ := '  Params.CreateParam('+ a_ftlist.Strings[i_]+','+''''+':v' +  inttostr(i_ + 1)+ '''' + ', ptInput); ';
  s_ := s_ + 'ParamByName('+''''+':v' +  inttostr(i_ + 1)+ ''''+').'+a_aslist.Strings[i_] + ' := ;';
  memo1.Lines.Add(s_);
end;
  s_ := '  Prepare;';
  memo1.Lines.Add(s_);
  s_ := '  try';
  memo1.Lines.Add(s_);
  s_ := '    ExecSQL;';
  memo1.Lines.Add(s_);
  s_ := '  except';
  memo1.Lines.Add(s_);
  s_ := '  end;';
  memo1.Lines.Add(s_);
  s_ := 'end;';
  memo1.Lines.Add(s_);
end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   s_ :string;
   i_ :integer;
begin
if (retrieve_fields) and (qname_ok) then begin
     memo1.Lines.Clear;
  s_ := 'with ' + wq_ + ' do begin';  memo1.Lines.Add(s_);
  s_ := '  if active then Close; UnPrepare; SQL.Clear;';  memo1.Lines.Add(s_);
  s_ := '  SQL.Add('+''''+'update ' + cb2.Text + ' set ';
for i_ := 0 to a_fldlist.Count - 1 do
begin
  if i_ <> 0 then s_ := s_ + ', ';
  s_ := s_ + a_fldlist.Strings[i_] + '=:v' +  inttostr(i_ + 1);
end;
  s_ := s_ + '''' + ');';  memo1.Lines.Add(s_);
  s_ := '  SQL.Add('+''''+'where ' + a_fldlist.Strings[0] + '=:v' + inttostr(a_fldlist.Count + 1)+ '''' + ');';
  memo1.Lines.Add(s_);
  s_ := '  Params.Clear;';  memo1.Lines.Add(s_);
for i_ := 0 to a_fldlist.Count - 1 do
begin
  s_ := '  Params.CreateParam('+ a_ftlist.Strings[i_] +','+''''+':v' +  inttostr(i_ + 1)+ '''' + ', ptInput); ';
  s_ := s_ + 'ParamByName('+''''+':v' +  inttostr(i_ + 1)+ ''''+').'+a_aslist.Strings[i_] + ' := ;';
  memo1.Lines.Add(s_);
end;
  s_ := '  Params.CreateParam('+ a_ftlist.Strings[0] +','+''''+':v' +  inttostr(a_fldlist.Count + 1)+ '''' + ', ptInput); ';
  s_ := s_ + 'ParamByName('+''''+':v' +  inttostr(a_fldlist.Count + 1)+ ''''+').'+a_aslist.Strings[0] + ' := ;';
  memo1.Lines.Add(s_);
  s_ := '  Prepare;';
  memo1.Lines.Add(s_);
  s_ := '  try';
  memo1.Lines.Add(s_);
  s_ := '    ExecSQL;';
  memo1.Lines.Add(s_);
  s_ := '  except';
  memo1.Lines.Add(s_);
  s_ := '  end;';
  memo1.Lines.Add(s_);
  s_ := 'end;';
  memo1.Lines.Add(s_);
end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   s_ :string;
begin
if (retrieve_fields) and (qname_ok) then begin
     memo1.Lines.Clear;
  s_ := 'with ' + wq_ + ' do begin';  memo1.Lines.Add(s_);
  s_ := '  if active then Close; UnPrepare; SQL.Clear;';  memo1.Lines.Add(s_);
  s_ := '  SQL.Add('+''''+'delete from ' + cb2.Text + ' where ' + a_fldlist.Strings[0] + '=:v1' + ''''+');';
  memo1.Lines.Add(s_);
  s_ := '  Params.Clear;';  memo1.Lines.Add(s_);
  s_ := '  Params.CreateParam('+ a_ftlist.Strings[0] + ','+''''+':v1'+ '''' + ', ptInput); ';
  s_ := s_ + 'ParamByName('+''''+':v1'+ ''''+').'+a_aslist.Strings[0] + ' := ;';
  memo1.Lines.Add(s_);
  s_ := '  Prepare;';
  memo1.Lines.Add(s_);
  s_ := '  try';
  memo1.Lines.Add(s_);
  s_ := '    ExecSQL;';
  memo1.Lines.Add(s_);
  s_ := '  except';
  memo1.Lines.Add(s_);
  s_ := '  end;';
  memo1.Lines.Add(s_);
  s_ := 'end;';
  memo1.Lines.Add(s_);
end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
   a_list :TStringList;
begin
   cb1.Items.Clear;
   a_list := TStringList.Create;
   with Session do
   begin
     if Active then Active := FALSE;
     SQLHourGlass := False;
     if (not Active) then Active := TRUE;
     GetAliasNames(a_list);
   end;
   cb1.Items.Assign(a_list);
   a_list.Free;
end;

procedure TForm1.cb1Change(Sender: TObject);
var
   try_open_ok :boolean;
   a_list      :TStringList;
begin
if cb1.Text <> '' then with db1 do begin
   cb2.Items.Clear; cb2.Text := '';
   if Connected then Close;
   AliasName := cb1.Text;
   try_open_ok := True;
   a_list := TStringList.Create;
  try
    Session.GetTableNames(cb1.Text,'',True,True,a_list);
  except
    try_open_ok := False;
  end;
  if try_open_ok then begin
    label2.Enabled := True;
    cb2.Enabled := True;
    cb2.Items := a_list;
    a_list.Free;
  end else begin
    label2.Enabled := False;
    cb2.Enabled := False;
  end;
end;
end;

function TForm1.retrieve_fields:boolean;
var
   try_open_ok :boolean;
   i           :integer;
begin
    Result := True;
    if a_fldlist = nil then a_fldlist := TStringList.Create;  a_fldlist.Clear;
    if a_ftlist = nil then a_ftlist := TStringList.Create; a_ftlist.Clear;
    if a_aslist = nil then a_aslist := TStringList.Create; a_aslist.Clear;
if cb2.Text <> '' then with table1 do begin
    if active then close;
    tablename := cb2.Text; try_open_ok := True;
  try
    Open;
  except
    try_open_ok := False;
  end;
    if try_open_ok then for i := 0 to FieldCount - 1 do
  begin
    a_fldlist.Add(Table1.Fields[i].FieldName);
    a_ftlist.Add(return_fldtype(Table1.FieldDefs.Items[i].DataType));
    a_aslist.Add(return_astype(Table1.FieldDefs.Items[i].DataType));
  end else Result := False;
end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    if a_fldlist <> nil then a_fldlist.Free;
    if a_ftlist <> nil then a_ftlist.Free;
    if a_aslist <> nil then a_aslist.Free;
    if db1.Connected then db1.Close;
end;

function TForm1.qname_ok:boolean;
begin
     wq_ := Edit1.text;
     if wq_ <> '' then Result := True else
   begin
     Result := False;
     showmessage('Query component name is missing.');
   end;
end;

function TForm1.return_fldtype(in_ :TFieldType):string;
begin
   case in_ of
     ftString, ftMemo : Result := 'ftString';
     ftSmallint, ftInteger, ftWord : Result := 'ftInteger';
     ftDate, ftTime, ftDateTime : Result := 'ftDateTime';
   else Result := 'ftString';
   end;
end;

function TForm1.return_astype(in_ :TFieldType):string;
begin
   case in_ of
     ftString, ftMemo : Result := 'AsString';
     ftSmallint, ftInteger, ftWord : Result := 'AsInteger';
     ftDate, ftTime, ftDateTime : Result := 'AsDateTime';
   else Result := 'AsString';
   end;
end;

end.
